<?php
// $Id: view.inc,v 1.4.4.5 2007/11/26 04:30:37 pyutaros Exp $
function family_make_link($fid, $text) {
  $nid = db_result(db_query("SELECT nid FROM {family_facts} WHERE fid = %d", $fid));
  $output = l($text,"node/$nid");
  return $output;
}

function family_make_name($fid)
{
  if ($fid) {
    if (family_check_privacy($fid)) {
      $personfact = family_getfacts($fid);
      $name = $personfact['NAME']['value'];
        if ($name) {
          if (preg_match("/^(.*)\/(.*)\/(.*)$/i", $name , $matches)) {
            $surname = strtoupper($matches[2]);
            $firstname = $matches[1].$matches[3];
            if (empty($surname)) {
              $surname = "UNKNOWN";
            }
            if (empty($firstname)) {
              $firstname = "Unknown";
            }
          }
          $name=$firstname.' '.$surname;
        }
        else {
          $name="Unknown";
        }
    }
    else {
      return 'Private';
    }
    return family_make_link($fid,$name);
  }
  else {
    return "Error!";
  }
}

function family_indi_list($indilist) {
  $output = '';
  $header = array(
    'Last Name',
    'First Name',
    'Sex',
    'Birth Date',
    //'Birth Place',
    'Death Date',
    //'Death Place'
  );
  $facts = array();
  if ($indilist=='ALL') {
    $results = db_query("SELECT fid FROM {family_facts} WHERE fact_code = 'INDI'");
    while($indi = db_fetch_array($results)){
        $individuals[] = $indi['fid'];
    }
  }
  else {
    $individuals = $indilist;
  }
  if ( count($individuals) > 0 ) {
    foreach($individuals as $idx=>$fid) {
      if (family_check_privacy($fid)) {
        $personfact = family_getfacts($fid);
        $name = $personfact['NAME']['value'];
        if ($name) {
          if (preg_match("/^(.*)\/(.*)\/(.*)$/i", $name , $matches)) {
            $surname = $matches[2];
            $firstname = $matches[1].$matches[3];
          }
          $name=str_replace("/","",$name); //Remove slashes arround surname
        }
        else {
          $name="Unknown";
        }
        $birth = $personfact['BIRT'];
        $birthfacts = family_getfacts($birth['fid']);
        $death = $personfact['DEAT'];
        $deathfacts = family_getfacts($death['fid']);
        $facts[$fid] = array(
          'SURN' => family_make_link($fid, $surname),
          'GIVN' => family_make_link($fid, $firstname),
          'SEX' => family_make_link($fid, $personfact['SEX']['value']),
          'BIRTD' => family_make_link($fid, $birthfacts['DATE']['value']),
          //'BIRTP' => family_make_link($fid, $birthfacts['PLAC']['value']),
          'DEATD' => family_make_link($fid, $deathfacts['DATE']['value']),
          //'DEATP' => family_make_link($fid, $deathfacts['PLAC']['value'])
        );
      }
      elseif ($indilist != 'ALL') {  //Avoid listing all the private in the global listing
        $facts[$fid] = array(
          'SURN' => 'Private',
          'GIVN' => '',
          'SEX' => '',
          'BIRTD' => '',
          //'BIRTP' => '',
          'DEATD' => '',
          //'DEATP' => ''
        );
      }
    }
  }

  $output .= '<div class="family-index">'.theme('table', $header, $facts)."</div>";
  return $output;
}

// Generate short description of event
function family_show_short_event ($fid){
  $events_full = array('BIRT'=>'Born', 'MARR'=>'Married', 'DEAT'=>'Died', 'ADOP'=>'Adopted',
                       'BURI'=>'Burried', 'EMIG'=>'Emigrated', 'ENGA'=>'Engaged', 'DIV'=>'Divorce');
  $fact = family_get_fact_by_fid($fid);
  $content=$events_full[$fact['code']];
  $seperator=": ";
  if ( $place = family_get_subvalue_by_code('PLAC',$fid) ){
    $content .= $seperator.$place;
    $seperator=", ";
  }
  if ( $date = family_get_subvalue_by_code('DATE',$fid) ){
    $content .= $seperator.$date;
  }
  if ( $cite_fact = family_get_subfact_by_code('SOUR', $fid)){
  	$content .=" <span style=\"vertical-align: super; font-size: smaller;\">[" .
               l( family_view_citation_short($cite_fact['fid']),
                  "family/view/citation/".$cite_fact['fid'] ) .
               "]</span>";
  }
  return($content);
}

// Generate summary of individual information
function family_line_indi ($fid) {
  $content="<P>";
  $content .= "<strong>". family_make_name($fid) ."</strong>";
  if ($show_record = family_check_privacy($fid)) {
    $sex = db_result(db_query("SELECT f.fact_value FROM {family_facts} f, {family_relations} r ".
            "WHERE (f.fact_code = '%s' AND f.fid=r.fid1 AND r.fid2= %d)", "SEX",$fid));
    if ($sex) {
      $content .= ", ".$sex;
    }
    $content .= "<br>";
  }

//Find parents
  $fam = db_result(db_query("SELECT f.fid FROM {family_facts} f, {family_relations} r ".
          "WHERE (f.fact_code = '%s' AND f.fid=r.fid2 AND r.fid1= %d AND r.relation_description='%s')", "FAM",$fid,"CHIL"));
  if ($fam) {
    $father = db_result(db_query("SELECT fid1 FROM {family_relations} WHERE (fid2 = %d AND relation_description='%s')", $fam, "HUSB"));
    if ($father) {
      $list[] = 'Father: '. family_make_name($father);
    }
    $mother = db_result(db_query("SELECT fid1 FROM {family_relations} WHERE (fid2 = %d AND relation_description='%s')", $fam, "WIFE"));
    if ($mother) {
      $list[] = 'Mother: '. family_make_name($mother);
    }
  }
  if ($show_record) {
    $birth = db_result(db_query("SELECT f.fid FROM {family_facts} f, {family_relations} r ".
            "WHERE (f.fact_code = '%s' AND f.fid=r.fid1 AND r.fid2= %d)", "BIRT",$fid));
    if ($birth) {
      $list[] = family_show_short_event($birth);
    }
    $death = db_result(db_query("SELECT f.fid FROM {family_facts} f, {family_relations} r ".
            "WHERE (f.fact_code = '%s' AND f.fid=r.fid1 AND r.fid2= %d)", "DEAT",$fid));
    if ($death) {
      $list[] = family_show_short_event($death);
    }
  }
  $content .= theme('item_list', $list);
  $content .= "</P>";
  return ($content);
}

// Display family view of individual fid (fact id)
function family_view_indi($fid) {
  $content="";
  $subfacts = family_get_subfacts($fid);
  $content .= family_line_indi ($fid);

//Find families where the individual is husband or wife
  $families = db_query("SELECT f.fid FROM {family_facts} f, {family_relations} r ".
          "WHERE (f.fact_code = '%s' AND f.fid=r.fid2 AND r.fid1= %d AND".
          "(r.relation_description='%s' OR r.relation_description='%s'))", "FAM",$fid,"HUSB","WIFE");
    if ($families) {
    $list1 = array();
    for ($j = 0; $j < db_num_rows($families); $j++) {
      $fam_id=db_result($families,$j);
      $family = family_get_fam_by_famid($fam_id);

      //Spouse info
      if($family['HUSB'][0]['fid'] == $fid) {
        $spouse = $family['WIFE'][0]['fid'];
      }
      else {
        $spouse = $family['HUSB'][0]['fid'];
      }
      if ($spouse) {
        $parents=TRUE;
        $content .= "<hr><strong>Spouse: </strong>".family_line_indi($spouse);
        $spousename = family_make_name($spouse);
      }
      else {
        $content .= "<hr><p><strong>Spouse: </strong>Unknown</p>";
        $spousename = "Unknown";
      }
      //Marriage info

      if($marr_facts = family_get_subfact_by_code('MARR',$fam_id)){
        $marr_subfacts = family_get_subfacts($marr_facts['fid']);
        $content .='<div class="marriage_data"><p>Married: ';
        if($marr_subfacts['PLAC']){
          $content .= $marr_subfacts['PLAC'][0]['value'];
        }
        if($marr_subfacts['PLAC'] && $marr_subfacts['DATE']){
        	$content .= ", ";
        }
        if($marr_subfacts['DATE']){
          $content .= $marr_subfacts['DATE'][0]['value'];
        }
        $content .= '</p></div>';
      }

      //Children info
      if ($children = $family['CHIL']) {
        foreach($children as $idx => $child){
            $child_fids[] = $child['fid'];
        }
        $content .= 'Children of '. family_make_name($fid).' and '. $spousename .':'
                 .  family_indi_list($child_fids);
      }
    }
  }
  $content .= '<hr />'; //Break before sources, biography, and comments
  if($subfacts['SOUR']){
    $content .="<p>Sources: <ul>";
  	foreach($subfacts['SOUR'] as $idx => $idx_arr){
  		$content .= "<li>".family_view_citation_short($subfacts['SOUR'][$idx]['fid'])."</li>";
  	}
    $content .="</ul></p>";
  }
  return($content);
}

//View family record
function family_view_record($fid = 0) {

  $events_code = array('BIRT', 'MARR', 'DEAT', 'ADOP', 'BURI', 'EMIG', 'ENGA', 'DIV');
  $events_full = array('BIRT'=>'Born', 'MARR'=>'Married', 'DEAT'=>'Died', 'ADOP'=>'Adopted',
                       'BURI'=>'Burried', 'EMIG'=>'Emigrated', 'ENGA'=>'Engaged', 'DIV'=>'Divorce');
  $facts_code = array('OCCU', 'RESI', 'NATI', 'EDUC', 'RELI', 'TITL');
  $facts_full = array('OCCU'=>'Occupation', 'RESI'=>'Residence', 'NATI'=>'Nationalization',
                      'EDUC'=>'Education', 'RELI'=>'Religion', 'TITL'=>'Title');

  if (!is_numeric($fid)) {
    drupal_access_denied();
    return $content;
  }

// If no parameter has been defined, view individuals list
  if ($fid==0) {
    $content = family_indi_list("ALL");
    return $content;
  }
  $content = '<p>';

  $fact = db_fetch_array(db_query("SELECT fact_code,fact_value FROM {family_facts} WHERE fid = %d", $fid));
  $fact_code=$fact['fact_code'];
  $value=$fact['fact_value'];

  switch (TRUE) {
    case $fact_code=="INDI":
      $content.=family_view_indi($fid);
      break;

    case $fact_code=="FAM":
    /*
     * The FAM fact contains data about a marriage
     * However we remove that data from the fact table and put the pointers in the relations table
     * We should change the indi view to only show the parents, spouses, personal data
     *  and give links to a family group sheet view, activated by the system recieving the
     *  corresponding fact code and executing this case.
     *
     * For now we will forward to the HUSB, WIFE, or provide an error
     */
     $redir_fid = '';
     $couple = family_get_fam_by_famid($fid, array('HUSB','WIFE'));
     if($couple['HUSB']) {
     	$content .= family_view_indi($couple['HUSB'][0]['fid']);
     }
     elseif($couple['WIFE']) {
     	$content .= family_view_indi($couple['WIFE'][0]['fid']);
     }
     else{
     	$content .= "We are sorry but there seems to be an error with " .
     			    "this family link. Please got back and try another.";
     }
      break;

    case in_array($fact_code, $events_code):
      $content.="Event view is not supported in this version";
      break;

    default:
      $content.="Illegal record number";
      break;
  }
  $content.="</p>";
  return $content;
}

